import _extends from "@babel/runtime/helpers/esm/extends";
import { jsx as _jsx } from "react/jsx-runtime";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import PropTypes from 'prop-types';

var Button = function Button(_ref) {
  var children = _ref.children,
      href = _ref.href,
      target = _ref.target,
      disabled = _ref.disabled,
      isSubmit = _ref.isSubmit,
      isButton = _ref.isButton,
      link = _ref.link,
      Link = _ref.linkFactory,
      attrs = _objectWithoutPropertiesLoose(_ref, ["children", "href", "target", "disabled", "isSubmit", "isButton", "link", "linkFactory"]);

  if (isSubmit) attrs.type = 'submit';
  if (isButton) attrs.type = 'button';
  var defaultRel = target === '_blank' ? 'noopener' : undefined;
  var rel = attrs.rel || defaultRel;
  return link ? /*#__PURE__*/_jsx(Link, _extends({}, attrs, {
    href: href,
    target: target,
    rel: rel,
    children: children
  })) : /*#__PURE__*/_jsx("button", _extends({}, attrs, {
    disabled: disabled,
    children: children
  }));
};

Button.defaultProps = {
  // eslint-disable-next-line react/prop-types
  linkFactory: function linkFactory(_temp) {
    var _ref2 = _temp === void 0 ? {} : _temp,
        children = _ref2.children,
        rest = _objectWithoutPropertiesLoose(_ref2, ["children"]);

    return /*#__PURE__*/_jsx("a", _extends({}, rest, {
      children: children
    }));
  }
};
export default Button;